Mercurial > hg
view tests/testlib/merge-combination-util.sh @ 46472:98e39f04d60e
upgrade: implement partial upgrade for upgrading persistent-nodemap
Upgrading repositories to use persistent nodemap should be fast and easy as it
requires only two things:
1) Updating the requirements
2) Writing a persistent-nodemap on disk
For both of the steps above, we don't need to edit existing revlogs.
This patch makes upgrade only do the above mentioned two steps if we are
only upgarding to use persistent-nodemap feature.
Since `nodemap.persist_nodemap()` assumes that there exists a nodemap file for
the given revlog if we are trying to call it, this patch adds `force` argument
to create a file if does not exist which is true in our upgrade case.
The test changes demonstrate that we no longer write nodemap files for manifest
after upgrade which I think is desirable.
Differential Revision: https://phab.mercurial-scm.org/D9936
author | Pulkit Goyal <7895pulkit@gmail.com> |
---|---|
date | Mon, 01 Feb 2021 00:02:00 +0530 |
parents | e8b0c519dfb3 |
children |
line wrap: on
line source
# genmerges is the workhorse of the test-merge-combination-*.t tests. # Given: # - a `range` function describing the possible values for file a # - a `isgood` function to filter out uninteresting combination # - a `createfile` function to actually write the values for file a on the # filesystem # # it print a series of lines that look like: abcd C: output of -T {files} # describing the file a at respectively the base, p2, p1, merge # revision. "C" indicates that hg merge had conflicts. genmerges () { (LC_ALL=C type range | grep -q 'function') || (echo >&2 "missing function: range") (LC_ALL=C type isgood | grep -q 'function') || (echo >&2 "missing function: isgood") (LC_ALL=C type createfile | grep -q 'function') || (echo >&2 "missing function: createfile") for base in `range` -; do for r1 in `range $base` -; do for r2 in `range $base $r1` -; do for m in `range $base $r1 $r2` -; do line="$base$r1$r2$m" isgood $line || continue hg init repo cd repo make_commit () { v=$1; msg=$2; file=$3; if [ $v != - ]; then createfile $v else if [ -f a ] then rm a else touch $file fi fi hg commit -q -Am $msg || exit 123 } echo foo > foo make_commit $base base b make_commit $r1 r1 c hg up -r 0 -q make_commit $r2 r2 d hg merge -q -r 1 > ../output 2>&1 if [ $? -ne 0 ]; then rm -f *.orig; hg resolve -m --all -q; fi if [ -s ../output ]; then conflicts=" C"; else conflicts=" "; fi make_commit $m m e if [ $m = $r1 ] && [ $m = $r2 ] then expected= elif [ $m = $r1 ] then if [ $base = $r2 ] then expected= else expected=a fi elif [ $m = $r2 ] then if [ $base = $r1 ] then expected= else expected=a fi else expected=a fi got=`hg log -r 3 --template '{files}\n' | tr -d 'e '` if [ "$got" = "$expected" ] then echo "$line$conflicts: agree on \"$got\"" else echo "$line$conflicts: hg said \"$got\", expected \"$expected\"" fi cd ../ rm -rf repo done done done done }